C H. K. D. H. Bhadehsia and Qin Bo
C 2006
C
C 'A' is the 1 x 3 matrix, defining the tensile axis
C 'T' is the 3 x 3 matrix, defining the twinning deformation
C 'H' is a 1 x 3 matrix, defining the twinning plane
C 'U' is a 1 x 3 matrix, defining the twinning direction
C 'SMF' is schmid factor of a twinning system for a particular
C    tensile axis


	 PROGRAM MAIN
C define variables	 
	 DOUBLE PRECISION A(3)
	 DOUBLE PRECISION T1(9),T2(9),T3(9),T4(9),T5(9),T6(9),
     &     T7(9),T8(9),T9(9),T10(9),T11(9),T12(9),TMAX(9)
	 DOUBLE PRECISION H1(3),H2(3),H3(3),H4(3),
     &   	U1(3),U2(3),U3(3),U4(3),U5(3),U6(3),U7(3),
     &   	U8(3),U9(3),U10(3),U11(3),U12(3),MAG,MAGA,MAGB
	DOUBLE PRECISION ELONG,A1(3),AB_R

	 INTEGER I,J,K,LOOP,NG
	 INTEGER SIG
C end of definition of variables
        WRITE(*,1)
1     	FORMAT(/ 2X, 'How many directions do you want to calculate?')
        READ(*,*) NG
        WRITE(*,*) '  TENSION OR COMPRESSION'
        WRITE(*,*) '  1:  TENSION'
        WRITE(*,*) ' -1:  COMPRESSION'
        READ(*,*)  SIG
C        
	DO 10 LOOP = 1,NG

	A(1)=RAND()-0.5
	A(2)=RAND()-0.5	
	A(3)=RAND()-0.5
	CALL NORM(A)
	OPEN (UNIT = 11, FILE = 'ALL-DIRECTION.TXT', STATUS = 'NEW')
C     
	 CALL TWIN(T1,T2,T3,T4,T5,T6,
     &      T7,T8,T9,T10,T11,T12,TMAX,
     &      H1,H2,H3,H4,
     &	   U1,U2,U3,U4,U5,U6,U7,
     &	   U8,U9,U10,U11,U12,A,SIG)
C 
	CALL STRAIN(TMAX,A,ELONG)
C
	IF (ELONG .GT. 0) THEN	
	     A1(1)=ELONG*A(1)
	     A1(2)=ELONG*A(2)
	     A1(3)=ELONG*A(3)
	ELSE
	     A1(1)=-ELONG*A(1)
	     A1(2)=-ELONG*A(2)
	     A1(3)=-ELONG*A(3)	
	ENDIF
	WRITE (11,111) A1(1),A1(2),A1(3)
111	FORMAT (F8.4,2X,F8.4,2X,F8.4)
     	
10	CONTINUE

	STOP
	END

	 

C	SUBROUTINES
C Subroutine to calculate deformation matrix
	   SUBROUTINE DEFORM(T,H,U)
C Reference: Geometry of Crystals, Worked Examples, Bhadeshia,
	   DOUBLE PRECISION T(9),H(3),U(3),M
C M is the twinning shear	   
	   M=1.0D+00/DSQRT(2.0D+00)
	   
	   T(1)=1.0D+00 +M*U(1)*H(1)
	   	   T(2)=M*U(1)*H(2)
	   	   	   T(3)=M*U(1)*H(3)
	   	   	   
	   T(4)=M*U(2)*H(1)
	   	   T(5)=1.0D+00+M*U(2)*H(2)
	   	   	  		 T(6)=M*U(2)*H(3)
	   	   	   
	   T(7)=M*U(3)*H(1)
	   	   T(8)=M*U(3)*H(2)
	   	   	   T(9)=1.0D+00+M*U(3)*H(3)	   	   	   
	   RETURN
	   END
C----------------------------------------------------------------
C Subroutine to normalise the components of a vector
C 'A' is a vector
C 'MAG' is its magnitude
C
      SUBROUTINE NORM(A)
      DOUBLE PRECISION A(3),X,Y,Z,MAG
C
		X=A(1)
		Y=A(2)
		Z=A(3)
        MAG=DSQRT(X*X+Y*Y+Z*Z)
        X=X/MAG
        Y=Y/MAG
        Z=Z/MAG
        A(1)=X
        A(2)=Y
        A(3)=Z
C
      RETURN
      END
C----------------------------------------------------------------
C Subroutine to define all the twinning matrices
C
      SUBROUTINE TWIN(T1,T2,T3,T4,T5,T6,
     &      T7,T8,T9,T10,T11,T12,TMAX,
     &      H1,H2,H3,H4,
     &	   U1,U2,U3,U4,U5,U6,U7,
     &	   U8,U9,U10,U11,U12,A,SIG)
C	
	 DOUBLE PRECISION T1(9),T2(9),T3(9),T4(9),T5(9),T6(9),
     &	   T7(9),T8(9),T9(9),T10(9),T11(9),T12(9)
	 DOUBLE PRECISION H1(3),H2(3),H3(3),H4(3),
     &   	U1(3),U2(3),U3(3),U4(3),U5(3),U6(3),U7(3),
     &   	U8(3),U9(3),U10(3),U11(3),U12(3),SMF(12),
     &       A(3)
         DOUBLE PRECISION TMAX(9),HMAX(3),UMAX(3),SMFMAX
         INTEGER I, MAXCOUNT, SIG
C Define twin planes	
	 H1(1)=1
	 H1(2)=1
	 H1(3)=1
C
	 H2(1)=1
	 H2(2)=-1
	 H2(3)=-1
C  
	 H3(1)=-1
	 H3(2)=1
	 H3(3)=-1
C
	 H4(1)=-1
	 H4(2)=-1
	 H4(3)=1
C
C Define twin directions in (111)
C	 
	 U1(1)=1
	 U1(2)=1
	 U1(3)=-2
C	 
	 U2(1)=1
	 U2(2)=-2
	 U2(3)=1
C	 
	 U3(1)=-2
	 U3(2)=1
	 U3(3)=1
C	Define twin directions in (1-1-1) 
C	 
	 U4(1)=1
	 U4(2)=2
	 U4(3)=-1
C	 
	 U5(1)=1
	 U5(2)=-1
	 U5(3)=2
C	 
	 U6(1)=-2
	 U6(2)=-1
	 U6(3)=-1
C	Define twin directions in (-11-1) 
C	 
	 U7(1)=-1
	 U7(2)=-2
	 U7(3)=-1
C	 
	 U8(1)=-1
	 U8(2)=1
	 U8(3)=2
C	 
	 U9(1)=2
	 U9(2)=1
	 U9(3)=-1
C
C	Define twin directions in (-1-11) 
	 U10(1)=-1
	 U10(2)=-1
	 U10(3)=-2
C	 
	 U11(1)=-1
	 U11(2)=2
	 U11(3)=1
C	 
	 U12(1)=2
	 U12(2)=-1
	 U12(3)=1
C
C Normalise everything to unit vectors
	 CALL NORM(H1)
	 	 CALL NORM(H2)
	 	 	 CALL NORM(H3)
	 	 	 	 CALL NORM(H4)
	 	 	 	 
	 CALL NORM(U1) 	 	
	 	 CALL NORM(U2) 
	 	 	 CALL NORM(U3) 	
	 	 	 	 
	 CALL NORM(U4) 	 	
	 	 CALL NORM(U5) 
	 	 	 CALL NORM(U6) 	 	 	 
	 	 	 	 
	 CALL NORM(U7) 	 	
	 	 CALL NORM(U8) 
	 	 	 CALL NORM(U9) 
	 	 	 	 
	 CALL NORM(U10) 	 	
	 	 CALL NORM(U11) 
	 	 	 CALL NORM(U12) 	 
C
C Calculate the twelve deformation matrices (F T F)
	 	 	 
	 CALL DEFORM(T1,H1,U1)
	 	 CALL DEFORM(T2,H1,U2)
	 	 	 CALL DEFORM(T3,H1,U3)
	 CALL DEFORM(T4,H2,U4)
	 	 CALL DEFORM(T5,H2,U5)
	 	 	 CALL DEFORM(T6,H2,U6)	 
	 CALL DEFORM(T7,H3,U7)
	 	 CALL DEFORM(T8,H3,U8)
	 	 	 CALL DEFORM(T9,H3,U9)
	 CALL DEFORM(T10,H4,U10)
	 	 CALL DEFORM(T11,H4,U11)
	 	 	 CALL DEFORM(T12,H4,U12)	
C
C Calculate the schmid factors
	CALL SCHMID(SMF(1),A,H1,U1,SIG)
	CALL SCHMID(SMF(2),A,H1,U2,SIG)
	CALL SCHMID(SMF(3),A,H1,U3,SIG)
	CALL SCHMID(SMF(4),A,H2,U4,SIG)
	CALL SCHMID(SMF(5),A,H2,U5,SIG)
	CALL SCHMID(SMF(6),A,H2,U6,SIG)
	CALL SCHMID(SMF(7),A,H3,U7,SIG)
	CALL SCHMID(SMF(8),A,H3,U8,SIG)
	CALL SCHMID(SMF(9),A,H3,U9,SIG)
	CALL SCHMID(SMF(10),A,H4,U10,SIG)
	CALL SCHMID(SMF(11),A,H4,U11,SIG)
	CALL SCHMID(SMF(12),A,H4,U12,SIG)

	CALL INITMAX(SMF(1),T1,H1,U1,SMFMAX,TMAX,HMAX,UMAX,MAXCOUNT)
	CALL FINDMAX(SMF(2),T2,H1,U2,SMFMAX,TMAX,HMAX,UMAX)
	CALL FINDMAX(SMF(3),T3,H1,U3,SMFMAX,TMAX,HMAX,UMAX)
	CALL FINDMAX(SMF(4),T4,H2,U4,SMFMAX,TMAX,HMAX,UMAX)
	CALL FINDMAX(SMF(5),T5,H2,U5,SMFMAX,TMAX,HMAX,UMAX)
	CALL FINDMAX(SMF(6),T6,H2,U6,SMFMAX,TMAX,HMAX,UMAX)
	CALL FINDMAX(SMF(7),T7,H3,U7,SMFMAX,TMAX,HMAX,UMAX)
	CALL FINDMAX(SMF(8),T8,H3,U8,SMFMAX,TMAX,HMAX,UMAX)
	CALL FINDMAX(SMF(9),T9,H3,U9,SMFMAX,TMAX,HMAX,UMAX)
	CALL FINDMAX(SMF(10),T10,H4,U10,SMFMAX,TMAX,HMAX,UMAX)
	CALL FINDMAX(SMF(11),T11,H4,U11,SMFMAX,TMAX,HMAX,UMAX)
	CALL FINDMAX(SMF(12),T12,H4,U12,SMFMAX,TMAX,HMAX,UMAX)

        
C	 CALL RITE(TMAX,HMAX,UMAX,SMFMAX) 
C	 CALL RITE(T1,H1,U1,SMF(1))
C	 CALL RITE(T2,H1,U2,SMF(2))
C	 CALL RITE(T3,H1,U3,SMF(3))	 
C	 CALL RITE(T4,H2,U4,SMF(4))
C	 CALL RITE(T5,H2,U5,SMF(5))
C	 CALL RITE(T6,H2,U6,SMF(6))	
C	 CALL RITE(T7,H3,U7,SMF(7))
C	 CALL RITE(T8,H3,U8,SMF(8))
C	 CALL RITE(T9,H3,U9,SMF(9))	 
C	 CALL RITE(T10,H4,U10,SMF(10))
C	 CALL RITE(T11,H4,U11,SMF(11))
C	 CALL RITE(T12,H4,U12,SMF(12)) 

	 RETURN
	 END
	 
C----------------------------------------------------------------
C Subroutine to WRITE nicely
C writes the deformation matrix (F T F), twin plane (H:F*)
C  and the twin direction [F:U]
C
      SUBROUTINE RITE(T,H,U,SMF)
      DOUBLE PRECISION T(9),H(3),U(3),SMF
C
      WRITE(*,1) H(1),H(2),H(3),U(1),U(2),U(3),SMF,
     &      T(1),T(2),T(3),T(4),T(5),T(6),T(7),T(8),T(9) 

1     FORMAT(/ 'the operating twinning system is:',
     &	     / 2X,'H=(', 3F7.4,')',2X,'U=[', 3F7.4,']', 2X, 'SMF=',F7.4
     &       / 2X,'|', 3F7.4,'|'/ 2X,'|',3F7.4,'|'/ 2X,'|',3F7.4,'|'/)	 
      RETURN
      END
C----------------------------------------------------------------
C
C Calculation of the elongation, when the whole of the austenite
C  transforms into a single twin variant, and the sample rotates
C  
C 'A' represents tensile axis in the austenite basis
C 'B' is the vector (F T F)[F;A]
C 'T' represents the deformation matrix (F T F)
C 'ELONG' represents the strain
C 'MAGA' is the magnitude of 'A'
C 'MAGB' is the magnitude of 'B'
C
	SUBROUTINE STRAIN(TMAX,A,ELONG)
	DOUBLE PRECISION TMAX(9), A(3), B(3), ELONG, MAGB, MAGA

	B(1)=TMAX(1)*A(1)+TMAX(2)*A(2)+TMAX(3)*A(3)
	B(2)=TMAX(4)*A(1)+TMAX(5)*A(2)+TMAX(6)*A(3)
	B(3)=TMAX(7)*A(1)+TMAX(8)*A(2)+TMAX(9)*A(3)

	MAGB=DSQRT(B(1)*B(1)+B(2)*B(2)+B(3)*B(3))
	MAGA=DSQRT(A(1)*A(1)+A(2)*A(2)+A(3)*A(3))
	ELONG = LOG(MAGB/MAGA)
	WRITE (*,3) ELONG
3	FORMAT('the true strain is: ', F8.4/)
	RETURN
	END
      

C 'SCHMID' means schmid factor
	SUBROUTINE SCHMID(SMF,A,H,U,SIG)
	DOUBLE PRECISION A(3),H(3), U(3),DOT1, DOT2, SMF
	INTEGER SIG
C
	CALL NORM(A)
		CALL NORM(H)
			CALL NORM(U)
	DOT1 = A(1)*H(1)+A(2)*H(2)+A(3)*H(3)
	DOT2 = A(1)*U(1)+A(2)*U(2)+A(3)*U(3)

	SMF = SIG*DOT1*DOT2
	
	RETURN
	END


C-----------------------------------------------------------------
C Find out the TMAX, HMAX, UMAX which has the maximum SMF
	SUBROUTINE FINDMAX(SMF,T,H,U,SMFMAX,TMAX,HMAX,UMAX)
	DOUBLE PRECISION T(9),H(3),U(3),SMF
	DOUBLE PRECISION TMAX(9),HMAX(3),UMAX(3),SMFMAX
        INTEGER I
	
	IF(SMF .GT. SMFMAX) THEN
	SMFMAX = SMF
	 
         DO 5 I=1,9
          TMAX(I) = T(I)
          IF(I .LT. 4) THEN
           HMAX(I) = H(I)
           UMAX(I) = U(I)
          ENDIF
5        CONTINUE

	ELSEIF(SMF .EQ. SMFMAX) THEN
         
	ENDIF

	RETURN
	END
C-------------------------------------------------------------------
C Initialize the TMAX, HMAX, UMAX and SMFMAX
	SUBROUTINE INITMAX(SMF,T,H,U,SMFMAX,TMAX,HMAX,UMAX,MAXCOUNT)
	DOUBLE PRECISION T(9),H(3),U(3),SMF
	DOUBLE PRECISION TMAX(9),HMAX(3),UMAX(3),SMFMAX
        INTEGER I
	
	 SMFMAX = SMF
         DO 5 I=1,9
          TMAX(I) = T(I)
          IF(I .LT. 4) THEN
           HMAX(I) = H(I)
           UMAX(I) = U(I)
          ENDIF
5        CONTINUE

	RETURN
	END
